package b4a.diabbuddy;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new anywheresoftware.b4a.ShellBA(this.getApplicationContext(), null, null, "b4a.diabbuddy", "b4a.diabbuddy.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.diabbuddy", "b4a.diabbuddy.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.diabbuddy.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}



public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = main.mostCurrent.processBA.sharedProcessBA.activityBA.get();
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

}
public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.sql.SQL _sql1 = null;
public static anywheresoftware.b4a.sql.SQL _sql2 = null;
public static int _currentindex = 0;
public static int _rownumber = 0;
public static int _currind = 0;
public static int _rownum = 0;
public static anywheresoftware.b4a.objects.collections.List _idlist = null;
public static anywheresoftware.b4a.objects.collections.List _midlist = null;
public static int _tabheight = 0;
public anywheresoftware.b4a.objects.EditTextWrapper _edtid = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtfirstname = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtlastname = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtmidname = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtaddy1 = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtaddy2 = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtcity = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtprovstate = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtpostalzip = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtcell = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtemail = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnadd = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btndelete = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnupdate = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnprevious = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnnext = null;
public anywheresoftware.b4a.objects.ScrollViewWrapper _scvtest = null;
public anywheresoftware.b4a.objects.ScrollViewWrapper _scvcontacts = null;
public anywheresoftware.b4a.objects.ScrollViewWrapper _scvmeas = null;
public anywheresoftware.b4a.objects.ScrollViewWrapper _scvmeds = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnltest = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnlmeds = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnlcontacts = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnlmeas = null;
public anywheresoftware.b4a.objects.TabHostWrapper _tbhmain = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtmeduid = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtmedid = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtmedname = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtmedsize = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtmedfreq = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtcomments = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblmeduid = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblmedid = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblmedname = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblmedsize = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblmedfreq = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblcomments = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnmadd = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnmdelete = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnmnext = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnmprevious = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnmupdate = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btncadd = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btncdelete = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btncnext = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btncprevious = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btncupdate = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnmsadd = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnmsdelete = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnmsnext = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnmsprevious = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnmsupdate = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtcontcomm = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtcontid = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtcontname = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtcontphone = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtcontrole = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtcontuid = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtlocation = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblcontcomm = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblcontid = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblcontloc = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblcontname = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblcontphone = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblcontrole = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblcontuid = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edmeascomm = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtfins = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtfood = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtglucose = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtmeasdate = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtmeastid = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtmeasuid = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtmins = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtmstim = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edtsins = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblfast = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblfood = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblglucose = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblinsulin = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblmeasdate = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblmeasid = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblmeasuid = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblmed = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblmstime = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblsins = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbmeascomm = null;
public b4a.diabbuddy.tabhostextras _tabhostextras = null;
public static String  _createdatabase() throws Exception{
RDebugUtils.currentModule="main";
String _q1 = "";
String _query = "";
RDebugUtils.currentLine=327680;
 //BA.debugLineNum = 327680;BA.debugLine="Sub CreateDataBase";
RDebugUtils.currentLine=327681;
 //BA.debugLineNum = 327681;BA.debugLine="Dim Q1, Query As String";
_q1 = "";
_query = "";
RDebugUtils.currentLine=327683;
 //BA.debugLineNum = 327683;BA.debugLine="Query = \"CREATE TABLE persons (ID INTEGER PRIMARY";
_query = "CREATE TABLE persons (ID INTEGER PRIMARY KEY, FirstName TEXT, MiddleName TEXT, LastName TEXT, "+"Address1 Text, Address2 Text, City TEXT, ProvState Text, PostalZip Text, Cell Text, eMail Text)";
RDebugUtils.currentLine=327686;
 //BA.debugLineNum = 327686;BA.debugLine="SQL1.ExecNonQuery(Query)";
_sql1.ExecNonQuery(_query);
RDebugUtils.currentLine=327688;
 //BA.debugLineNum = 327688;BA.debugLine="Q1 = \"CREATE TABLE meds ( UserID INTEGER, MedID I";
_q1 = "CREATE TABLE meds ( UserID INTEGER, MedID INTEGER, MedName TEXT, MedDose TEXT, MedFreq TEXT, MedComm TEXT, PRIMARY KEY(UserID, MedID) )";
RDebugUtils.currentLine=327690;
 //BA.debugLineNum = 327690;BA.debugLine="SQL1.ExecNonQuery(Q1)";
_sql1.ExecNonQuery(_q1);
RDebugUtils.currentLine=327692;
 //BA.debugLineNum = 327692;BA.debugLine="Query = \"CREATE TABLE contacts ( UserID INTEGER,";
_query = "CREATE TABLE contacts ( UserID INTEGER, ContID INTEGER, ContName TEXT, ContRole TEXT, ContPhone TEXT, "+"ContLocation TEXT, ContComm TEXT, PRIMARY KEY(UserID, ContID) )";
RDebugUtils.currentLine=327695;
 //BA.debugLineNum = 327695;BA.debugLine="SQL1.ExecNonQuery(Query)";
_sql1.ExecNonQuery(_query);
RDebugUtils.currentLine=327697;
 //BA.debugLineNum = 327697;BA.debugLine="Q1 = \"CREATE TABLE measure ( UserID INTEGER, Meas";
_q1 = "CREATE TABLE measure ( UserID INTEGER, MeasID INTEGER, mDate TEXT, mTime TEXT, Glucose REAL, "+"FastInsulin Integer, MedInsulin Integer, SlowInsulin Integer, Food TEXT, Comments TEXT, PRIMARY KEY(UserID, MeasID) )";
RDebugUtils.currentLine=327700;
 //BA.debugLineNum = 327700;BA.debugLine="SQL1.ExecNonQuery(Q1)";
_sql1.ExecNonQuery(_q1);
RDebugUtils.currentLine=327703;
 //BA.debugLineNum = 327703;BA.debugLine="End Sub";
return "";
}
public static String  _showentry(int _entryindex) throws Exception{
RDebugUtils.currentModule="main";
anywheresoftware.b4a.sql.SQL.CursorWrapper _cursor1 = null;
anywheresoftware.b4a.sql.SQL.CursorWrapper _cursor2 = null;
int _id = 0;
int _mid = 0;
RDebugUtils.currentLine=458752;
 //BA.debugLineNum = 458752;BA.debugLine="Sub ShowEntry(EntryIndex As Int)";
RDebugUtils.currentLine=458753;
 //BA.debugLineNum = 458753;BA.debugLine="Dim Cursor1, Cursor2 As Cursor";
_cursor1 = new anywheresoftware.b4a.sql.SQL.CursorWrapper();
_cursor2 = new anywheresoftware.b4a.sql.SQL.CursorWrapper();
RDebugUtils.currentLine=458754;
 //BA.debugLineNum = 458754;BA.debugLine="Dim ID, MID As Int";
_id = 0;
_mid = 0;
RDebugUtils.currentLine=458756;
 //BA.debugLineNum = 458756;BA.debugLine="If IDList.Size = 0 Then 			'check if the database";
if (_idlist.getSize()==0) { 
RDebugUtils.currentLine=458757;
 //BA.debugLineNum = 458757;BA.debugLine="Return											'if yes leave the routine";
if (true) return "";
 };
RDebugUtils.currentLine=458760;
 //BA.debugLineNum = 458760;BA.debugLine="ID = IDList.Get(EntryIndex)		'get the ID for the";
_id = (int)(BA.ObjectToNumber(_idlist.Get(_entryindex)));
RDebugUtils.currentLine=458762;
 //BA.debugLineNum = 458762;BA.debugLine="Cursor1 = SQL1.ExecQuery(\"SELECT * FROM persons W";
_cursor1.setObject((android.database.Cursor)(_sql1.ExecQuery("SELECT * FROM persons WHERE ID = "+BA.NumberToString(_id))));
RDebugUtils.currentLine=458763;
 //BA.debugLineNum = 458763;BA.debugLine="edtID.Text = ID																			'display the ID";
mostCurrent._edtid.setText((Object)(_id));
RDebugUtils.currentLine=458764;
 //BA.debugLineNum = 458764;BA.debugLine="Cursor1.Position = 0																'set the curs";
_cursor1.setPosition((int) (0));
RDebugUtils.currentLine=458765;
 //BA.debugLineNum = 458765;BA.debugLine="edtFirstName.Text = Cursor1.GetString(\"FirstName\"";
mostCurrent._edtfirstname.setText((Object)(_cursor1.GetString("FirstName")));
RDebugUtils.currentLine=458766;
 //BA.debugLineNum = 458766;BA.debugLine="edtMidName.Text = Cursor1.GetString(\"MiddleName\")";
mostCurrent._edtmidname.setText((Object)(_cursor1.GetString("MiddleName")));
RDebugUtils.currentLine=458767;
 //BA.debugLineNum = 458767;BA.debugLine="edtLastName.Text = Cursor1.GetString(\"LastName\")";
mostCurrent._edtlastname.setText((Object)(_cursor1.GetString("LastName")));
RDebugUtils.currentLine=458768;
 //BA.debugLineNum = 458768;BA.debugLine="edtAddy1.Text = Cursor1.GetString(\"Address1\")";
mostCurrent._edtaddy1.setText((Object)(_cursor1.GetString("Address1")));
RDebugUtils.currentLine=458769;
 //BA.debugLineNum = 458769;BA.debugLine="edtAddy2.Text = Cursor1.GetString(\"Address2\")";
mostCurrent._edtaddy2.setText((Object)(_cursor1.GetString("Address2")));
RDebugUtils.currentLine=458770;
 //BA.debugLineNum = 458770;BA.debugLine="edtCity.Text = Cursor1.GetString(\"City\")						're";
mostCurrent._edtcity.setText((Object)(_cursor1.GetString("City")));
RDebugUtils.currentLine=458771;
 //BA.debugLineNum = 458771;BA.debugLine="edtProvState.Text = Cursor1.GetString(\"ProvState\"";
mostCurrent._edtprovstate.setText((Object)(_cursor1.GetString("ProvState")));
RDebugUtils.currentLine=458772;
 //BA.debugLineNum = 458772;BA.debugLine="edtPostalZip.Text = Cursor1.GetString(\"PostalZip\"";
mostCurrent._edtpostalzip.setText((Object)(_cursor1.GetString("PostalZip")));
RDebugUtils.currentLine=458773;
 //BA.debugLineNum = 458773;BA.debugLine="edtCell.Text = Cursor1.GetString(\"Cell\")";
mostCurrent._edtcell.setText((Object)(_cursor1.GetString("Cell")));
RDebugUtils.currentLine=458774;
 //BA.debugLineNum = 458774;BA.debugLine="edteMail.Text = Cursor1.GetString(\"eMail\")";
mostCurrent._edtemail.setText((Object)(_cursor1.GetString("eMail")));
RDebugUtils.currentLine=458775;
 //BA.debugLineNum = 458775;BA.debugLine="Cursor1.Close																				'close the curso";
_cursor1.Close();
RDebugUtils.currentLine=458786;
 //BA.debugLineNum = 458786;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=262144;
 //BA.debugLineNum = 262144;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
RDebugUtils.currentLine=262145;
 //BA.debugLineNum = 262145;BA.debugLine="If UserClosed Then";
if (_userclosed) { 
RDebugUtils.currentLine=262146;
 //BA.debugLineNum = 262146;BA.debugLine="SQL1.Close		'if the user closes the program we c";
_sql1.Close();
 };
RDebugUtils.currentLine=262148;
 //BA.debugLineNum = 262148;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=196608;
 //BA.debugLineNum = 196608;BA.debugLine="Sub Activity_Resume";
RDebugUtils.currentLine=196609;
 //BA.debugLineNum = 196609;BA.debugLine="If SQL1.IsInitialized = False Then";
if (_sql1.IsInitialized()==anywheresoftware.b4a.keywords.Common.False) { 
RDebugUtils.currentLine=196610;
 //BA.debugLineNum = 196610;BA.debugLine="SQL1.Initialize(File.DirInternal, \"persons.db\",";
_sql1.Initialize(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"persons.db",anywheresoftware.b4a.keywords.Common.True);
 };
RDebugUtils.currentLine=196612;
 //BA.debugLineNum = 196612;BA.debugLine="End Sub";
return "";
}
public static String  _addentry() throws Exception{
RDebugUtils.currentModule="main";
String _q1 = "";
String _q2 = "";
String _query = "";
anywheresoftware.b4a.sql.SQL.CursorWrapper _cursor1 = null;
int _id = 0;
RDebugUtils.currentLine=524288;
 //BA.debugLineNum = 524288;BA.debugLine="Sub AddEntry";
RDebugUtils.currentLine=524289;
 //BA.debugLineNum = 524289;BA.debugLine="Dim Q1, Q2, Query As String";
_q1 = "";
_q2 = "";
_query = "";
RDebugUtils.currentLine=524290;
 //BA.debugLineNum = 524290;BA.debugLine="Dim Cursor1 As Cursor";
_cursor1 = new anywheresoftware.b4a.sql.SQL.CursorWrapper();
RDebugUtils.currentLine=524291;
 //BA.debugLineNum = 524291;BA.debugLine="Dim ID As Int";
_id = 0;
RDebugUtils.currentLine=524294;
 //BA.debugLineNum = 524294;BA.debugLine="Q1 = \"SELECT * FROM persons WHERE FirstName = ? A";
_q1 = "SELECT * FROM persons WHERE FirstName = ? AND MiddleName = ? AND LastName = ?  AND Address1 = ? AND Address2 = ?"+" AND City = ? AND ProvState = ? AND PostalZip = ? AND Cell = ? AND eMail = ?";
RDebugUtils.currentLine=524296;
 //BA.debugLineNum = 524296;BA.debugLine="Query = Q1";
_query = _q1;
RDebugUtils.currentLine=524297;
 //BA.debugLineNum = 524297;BA.debugLine="Cursor1 = SQL1.ExecQuery2(Query, Array As String";
_cursor1.setObject((android.database.Cursor)(_sql1.ExecQuery2(_query,new String[]{mostCurrent._edtfirstname.getText(),mostCurrent._edtmidname.getText(),mostCurrent._edtlastname.getText(),mostCurrent._edtaddy1.getText(),mostCurrent._edtaddy2.getText(),mostCurrent._edtcity.getText(),mostCurrent._edtprovstate.getText(),mostCurrent._edtpostalzip.getText(),mostCurrent._edtcell.getText(),mostCurrent._edtemail.getText()})));
RDebugUtils.currentLine=524299;
 //BA.debugLineNum = 524299;BA.debugLine="If Cursor1.RowCount > 0 Then";
if (_cursor1.getRowCount()>0) { 
RDebugUtils.currentLine=524301;
 //BA.debugLineNum = 524301;BA.debugLine="ToastMessageShow(\"This entry already exists\", Fa";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("This entry already exists",anywheresoftware.b4a.keywords.Common.False);
 }else {
RDebugUtils.currentLine=524306;
 //BA.debugLineNum = 524306;BA.debugLine="Query = \"INSERT INTO persons VALUES (NULL, ?, ?,";
_query = "INSERT INTO persons VALUES (NULL, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
RDebugUtils.currentLine=524307;
 //BA.debugLineNum = 524307;BA.debugLine="SQL1.ExecNonQuery2(Query, Array As String(edtFir";
_sql1.ExecNonQuery2(_query,anywheresoftware.b4a.keywords.Common.ArrayToList(new String[]{mostCurrent._edtfirstname.getText(),mostCurrent._edtmidname.getText(),mostCurrent._edtlastname.getText(),mostCurrent._edtaddy1.getText(),mostCurrent._edtaddy2.getText(),mostCurrent._edtcity.getText(),mostCurrent._edtprovstate.getText(),mostCurrent._edtpostalzip.getText(),mostCurrent._edtcell.getText(),mostCurrent._edtemail.getText()}));
RDebugUtils.currentLine=524309;
 //BA.debugLineNum = 524309;BA.debugLine="ToastMessageShow(\"Entry added\", False)	' confirm";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Entry added",anywheresoftware.b4a.keywords.Common.False);
RDebugUtils.currentLine=524312;
 //BA.debugLineNum = 524312;BA.debugLine="ID = SQL1.ExecQuerySingleResult(\"SELECT max(ID)";
_id = (int)(Double.parseDouble(_sql1.ExecQuerySingleResult("SELECT max(ID) FROM persons")));
RDebugUtils.currentLine=524313;
 //BA.debugLineNum = 524313;BA.debugLine="RowNumber = RowNumber + 1					'increase the row";
_rownumber = (int) (_rownumber+1);
RDebugUtils.currentLine=524314;
 //BA.debugLineNum = 524314;BA.debugLine="IDList.Add(ID)										'add the last ID to the";
_idlist.Add((Object)(_id));
RDebugUtils.currentLine=524315;
 //BA.debugLineNum = 524315;BA.debugLine="CurrentIndex = IDList.Size - 1		'set the current";
_currentindex = (int) (_idlist.getSize()-1);
RDebugUtils.currentLine=524316;
 //BA.debugLineNum = 524316;BA.debugLine="edtID.Text = ID										'display the last index";
mostCurrent._edtid.setText((Object)(_id));
 };
RDebugUtils.currentLine=524318;
 //BA.debugLineNum = 524318;BA.debugLine="Cursor1.Close												'close the cursor, we do";
_cursor1.Close();
RDebugUtils.currentLine=524319;
 //BA.debugLineNum = 524319;BA.debugLine="End Sub";
return "";
}
public static String  _btnadd_click() throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=720896;
 //BA.debugLineNum = 720896;BA.debugLine="Sub btnAdd_Click";
RDebugUtils.currentLine=720897;
 //BA.debugLineNum = 720897;BA.debugLine="AddEntry";
_addentry();
RDebugUtils.currentLine=720898;
 //BA.debugLineNum = 720898;BA.debugLine="End Sub";
return "";
}
public static String  _btndelete_click() throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=786432;
 //BA.debugLineNum = 786432;BA.debugLine="Sub btnDelete_Click";
RDebugUtils.currentLine=786433;
 //BA.debugLineNum = 786433;BA.debugLine="DeleteEntry";
_deleteentry();
RDebugUtils.currentLine=786434;
 //BA.debugLineNum = 786434;BA.debugLine="End Sub";
return "";
}
public static String  _deleteentry() throws Exception{
RDebugUtils.currentModule="main";
String _query = "";
int _answ = 0;
RDebugUtils.currentLine=589824;
 //BA.debugLineNum = 589824;BA.debugLine="Sub DeleteEntry";
RDebugUtils.currentLine=589825;
 //BA.debugLineNum = 589825;BA.debugLine="Dim Query As String";
_query = "";
RDebugUtils.currentLine=589826;
 //BA.debugLineNum = 589826;BA.debugLine="Dim Answ As Int";
_answ = 0;
RDebugUtils.currentLine=589829;
 //BA.debugLineNum = 589829;BA.debugLine="Answ = Msgbox2(\"Do you really want to delete \" &";
_answ = anywheresoftware.b4a.keywords.Common.Msgbox2("Do you really want to delete "+mostCurrent._edtfirstname.getText()+" "+mostCurrent._edtlastname.getText(),"Delete entry","Yes","","No",(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.Null),mostCurrent.activityBA);
RDebugUtils.currentLine=589831;
 //BA.debugLineNum = 589831;BA.debugLine="If Answ = DialogResponse.POSITIVE Then			'if yes,";
if (_answ==anywheresoftware.b4a.keywords.Common.DialogResponse.POSITIVE) { 
RDebugUtils.currentLine=589832;
 //BA.debugLineNum = 589832;BA.debugLine="Query = \"DELETE FROM persons WHERE ID = \" & IDLi";
_query = "DELETE FROM persons WHERE ID = "+BA.ObjectToString(_idlist.Get(_currentindex));
RDebugUtils.currentLine=589833;
 //BA.debugLineNum = 589833;BA.debugLine="SQL1.ExecNonQuery(Query)									'delete the ent";
_sql1.ExecNonQuery(_query);
RDebugUtils.currentLine=589834;
 //BA.debugLineNum = 589834;BA.debugLine="IDList.RemoveAt(CurrentIndex)							'remove the";
_idlist.RemoveAt(_currentindex);
RDebugUtils.currentLine=589835;
 //BA.debugLineNum = 589835;BA.debugLine="If CurrentIndex = RowNumber - 1 Then			'if the c";
if (_currentindex==_rownumber-1) { 
RDebugUtils.currentLine=589836;
 //BA.debugLineNum = 589836;BA.debugLine="CurrentIndex = CurrentIndex - 1					'decrement";
_currentindex = (int) (_currentindex-1);
 };
RDebugUtils.currentLine=589838;
 //BA.debugLineNum = 589838;BA.debugLine="RowNumber = RowNumber - 1									'decrement the";
_rownumber = (int) (_rownumber-1);
RDebugUtils.currentLine=589839;
 //BA.debugLineNum = 589839;BA.debugLine="ShowEntry(CurrentIndex)										'show the next";
_showentry(_currentindex);
RDebugUtils.currentLine=589840;
 //BA.debugLineNum = 589840;BA.debugLine="ToastMessageShow(\"Entry deleted\", False)	'confir";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Entry deleted",anywheresoftware.b4a.keywords.Common.False);
 };
RDebugUtils.currentLine=589842;
 //BA.debugLineNum = 589842;BA.debugLine="End Sub";
return "";
}
public static String  _btnmsadd_click() throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=1310720;
 //BA.debugLineNum = 1310720;BA.debugLine="Sub btnMsAdd_Click";
RDebugUtils.currentLine=1310722;
 //BA.debugLineNum = 1310722;BA.debugLine="End Sub";
return "";
}
public static String  _btnmsdelete_click() throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=1245184;
 //BA.debugLineNum = 1245184;BA.debugLine="Sub btnMsDelete_Click";
RDebugUtils.currentLine=1245186;
 //BA.debugLineNum = 1245186;BA.debugLine="End Sub";
return "";
}
public static String  _btnmsnext_click() throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=1179648;
 //BA.debugLineNum = 1179648;BA.debugLine="Sub btnMsNext_Click";
RDebugUtils.currentLine=1179650;
 //BA.debugLineNum = 1179650;BA.debugLine="End Sub";
return "";
}
public static String  _btnmsprevious_click() throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=1114112;
 //BA.debugLineNum = 1114112;BA.debugLine="Sub btnMsPrevious_Click";
RDebugUtils.currentLine=1114114;
 //BA.debugLineNum = 1114114;BA.debugLine="End Sub";
return "";
}
public static String  _btnmsupdate_click() throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=1048576;
 //BA.debugLineNum = 1048576;BA.debugLine="Sub btnMsUpdate_Click";
RDebugUtils.currentLine=1048578;
 //BA.debugLineNum = 1048578;BA.debugLine="End Sub";
return "";
}
public static String  _btnnext_click() throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=983040;
 //BA.debugLineNum = 983040;BA.debugLine="Sub btnNext_Click";
RDebugUtils.currentLine=983041;
 //BA.debugLineNum = 983041;BA.debugLine="If CurrentIndex < RowNumber - 1 Then";
if (_currentindex<_rownumber-1) { 
RDebugUtils.currentLine=983042;
 //BA.debugLineNum = 983042;BA.debugLine="CurrentIndex = CurrentIndex + 1";
_currentindex = (int) (_currentindex+1);
RDebugUtils.currentLine=983043;
 //BA.debugLineNum = 983043;BA.debugLine="ShowEntry(CurrentIndex)";
_showentry(_currentindex);
 };
RDebugUtils.currentLine=983045;
 //BA.debugLineNum = 983045;BA.debugLine="End Sub";
return "";
}
public static String  _btnprevious_click() throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=917504;
 //BA.debugLineNum = 917504;BA.debugLine="Sub btnPrevious_Click";
RDebugUtils.currentLine=917505;
 //BA.debugLineNum = 917505;BA.debugLine="If CurrentIndex > 0 Then";
if (_currentindex>0) { 
RDebugUtils.currentLine=917506;
 //BA.debugLineNum = 917506;BA.debugLine="CurrentIndex = CurrentIndex - 1";
_currentindex = (int) (_currentindex-1);
RDebugUtils.currentLine=917507;
 //BA.debugLineNum = 917507;BA.debugLine="ShowEntry(CurrentIndex)";
_showentry(_currentindex);
 };
RDebugUtils.currentLine=917509;
 //BA.debugLineNum = 917509;BA.debugLine="End Sub";
return "";
}
public static String  _btnupdate_click() throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=851968;
 //BA.debugLineNum = 851968;BA.debugLine="Sub btnUpdate_Click";
RDebugUtils.currentLine=851969;
 //BA.debugLineNum = 851969;BA.debugLine="UpdateEntry";
_updateentry();
RDebugUtils.currentLine=851970;
 //BA.debugLineNum = 851970;BA.debugLine="End Sub";
return "";
}
public static String  _updateentry() throws Exception{
RDebugUtils.currentModule="main";
String _query = "";
RDebugUtils.currentLine=655360;
 //BA.debugLineNum = 655360;BA.debugLine="Sub UpdateEntry";
RDebugUtils.currentLine=655361;
 //BA.debugLineNum = 655361;BA.debugLine="Dim Query As String";
_query = "";
RDebugUtils.currentLine=655363;
 //BA.debugLineNum = 655363;BA.debugLine="Query = \"UPDATE persons Set FirstName = ?, Middle";
_query = "UPDATE persons Set FirstName = ?, MiddleName = ?, LastName = ?, Address1 = ?, Address2 = ?, City = ?, ProvState = ?, PostalZip = ?, Cell = ?, eMail = ? WHERE ID = "+BA.ObjectToString(_idlist.Get(_currentindex));
RDebugUtils.currentLine=655364;
 //BA.debugLineNum = 655364;BA.debugLine="SQL1.ExecNonQuery2(Query, Array As String(edtFirs";
_sql1.ExecNonQuery2(_query,anywheresoftware.b4a.keywords.Common.ArrayToList(new String[]{mostCurrent._edtfirstname.getText(),mostCurrent._edtmidname.getText(),mostCurrent._edtlastname.getText(),mostCurrent._edtaddy1.getText(),mostCurrent._edtaddy2.getText(),mostCurrent._edtcity.getText(),mostCurrent._edtprovstate.getText(),mostCurrent._edtpostalzip.getText(),mostCurrent._edtcell.getText(),mostCurrent._edtemail.getText()}));
RDebugUtils.currentLine=655365;
 //BA.debugLineNum = 655365;BA.debugLine="ToastMessageShow(\"Entry updated\", False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Entry updated",anywheresoftware.b4a.keywords.Common.False);
RDebugUtils.currentLine=655366;
 //BA.debugLineNum = 655366;BA.debugLine="End Sub";
return "";
}
}